Ubuntu

[Sandy Bridge] serious power regression from kernel 3.0.0-6 to 3.0.0-7 (rc6 disabled)

Reported by Alanwww1 on 2011-07-31
678
This bug affects 135 people
Affects Status Importance Assigned to Milestone
Linux
Fix Released
Medium
The Ubuntu Power Consumption Project
Undecided
Unassigned
linux (Ubuntu)
Medium
Canonical Kernel Team
Oneiric
Medium
Unassigned
Precise
Medium
Canonical Kernel Team

Bug Description

On Ubuntu Oneiric, I discovered a serious power regression from Kernel 3.0.0-6-generic to 3.0.0-7-generic.
It is on an Intel Sandy Bridge Laptop. Unplugging the laptop from ac power source I made the tests without any graphical user interface active with the same brightness and other settings. When I boot into the kernels I have the following idle power numbers with

grep rate /proc/acpi/battery/BAT0/state:

- Kernel 3.0.0-6: present rate: 1530-1560mW
- Kernel 3.0.0-7: present rate: 1950-2020mW

It is a more than 30% (!!!) increase in power usage withe the same hw, same settings, different Kernel version.
Which is really annoying as the laptop fans start working above 1700-1800mw, so it is night and day in usage comfort the laptop with the two kernels.

Here is the kernel log for both versions:

Log with 3.0.0-6: http://pastebin.com/e0UER3zf
Log with 3.0.0-7: http://pastebin.com/5JcrZ5Br

Please let me know if you need any more data on this.

The problem is 100% reproducible.

Julian Wiedmann (jwiedmann) wrote :

It's a Sandy Bridge machine, so commit
http://kernel.ubuntu.com/git?p=ubuntu/ubuntu-oneiric.git;a=commit;h=05bd42688dbc066d4e2689b6f73c0470601f788b
(added in 3.0.0-7.8) might be causing the regression. Try re-enabling rc6 and see if that makes a difference?

Alanwww1 (alanwww1) wrote :

@Julian

Thanks for the help. This was the cause of the power difference. Adding
 i915.i915_enable_rc6=1

to the kernel parameters at /etc/default/grub.cfg brought back the good power consumption level with the latest kernel image.

I hope the Intel Devs sort out the rest of the problems so this could be enabled by default. This really makes a difference with laptops.

Changed in linux (Ubuntu):
importance: Undecided → Medium
status: New → Triaged
summary: - Serious power regression from kernel 3.0.0-6 to 3.0.0-7 (30% more power
- at idle)
+ Sandy Bridge serious power regression from kernel 3.0.0-6 to 3.0.0-7
+ (30% more power at idle)

I am experiencing this same thing, but without an apparent workaround. After upgrading from kernel 2.6.38 to 3.0.0-0300, I saw a DRAMATIC increase in power usage on my Sandy Bridge laptop. I then upgraded to 3.1 and saw no improvement. Trying kernel parameter i915.i915_enable_rc6=1 made no difference whatsoever for me.

I am on a ThinkPad X220 with an Intel(R) Core(TM) i7-2620M CPU @ 2.70GHz.

I documented the symptoms of the problem at http://ubuntuforums.org/showthread.php?t=1822629

The bottom line of that thread is that powertop shows a HUGE number of wakeups from "[Rescheduling interrupts] <kernel IPI>" with the 3-series kernels and no such wakeups with older kernels.

Steven Keys (steevven1) wrote :

Maybe in light of my comment (or maybe if someone else can reproduce it), we should unmark this thread as "triaged," since the solution doesn't appear to work on all machines.

Steven Keys (steevven1) wrote :

Just noticed a typo in my post (Post #3): The two kernel versions I have experienced the problem on are 3.0.1-030001-generic and 3.0.1-030001-generic...I have NOT tried 3.1.

Julian Wiedmann (jwiedmann) wrote :

Steven:
as enabling rc6 doesn't help, yours is a different issue. Please file a new bug.

summary: - Sandy Bridge serious power regression from kernel 3.0.0-6 to 3.0.0-7
- (30% more power at idle)
+ [Sandy Bridge] serious power regression from kernel 3.0.0-6 to 3.0.0-7
+ (rc6 disabled)
Strongman332 (strongman332) wrote :

or maybe it is specific hw configurations that the rc6 fix works with. i think that more testing is needed on several other machines with sandy bridge cpus.

Steven Keys (steevven1) wrote :

I filed a new bug with a link to TONS more information over at ubuntuforums:

https://bugs.launchpad.net/ubuntu/+bug/834037

http://ubuntuforums.org/showthread.php?t=1822629

Steven Keys (steevven1) wrote :

I made a mistake previously and would like to clear it up. The mistake was a result of not giving something enough time and testing. I have now tested it more thoroughly and have more to report:

Using a modified (no sparse irq) kernel with kernel parameter i915.i915_enable_rc6=1 DOES increase battery life compared to without that kernel parameter. The only problem is that it also brings back the graphical glitches and freezes, which were the ONLY reason I wanted to switch to kernel 3.x in the first place. Thus, that kernel parameter in concert with disabling sparse irq in the kernel solves the power problem (completely or almost completely), but the i915.i915_enable_rc6=1 kernel parameter brings back the glitchy graphics from kernel 2.6.x.

I have also added this comment to the ubuntuforums thread, where it is in a bit better context.

In the context on THIS bug, I'd like to ask: Has anyone else experienced graphical glitches and/or freezes while using i915.i915_enable_rc6=1 with kernel 3.x?

Eric Liang (ericliang) wrote :

I'm seeing the same behavior with a i5-2410M (also on a Thinkpad X220).

With i915.i915_enable_rc6=1, power usage is ~12W, but textures seem to get corrupted over time.

Without rc6, power usage on idle is ~20W, but graphics are fine.

Steven Keys (steevven1) wrote :

Eric, if you could please put your information at the following link, it would be appreciated. You seem to be experiencing this bug: https://bugs.launchpad.net/ubuntu/+bug/834037

John Eikenberry (jae) wrote :

Just passing along what I've experienced with this bug. I also posted this on the
duplicate bug (#834037) in case one of them is marked as a duplicate.

X220 i7-2620M

I experience the difference in power usage w/ 3.x kernels and setting the
i915.i915_enable_rc6=1 parameter fixes this issue while bringing back the video corruption.

The video corruption for me takes the form of light and dark grey horizontal
stripes covering the screen. It always kicks in running on battery, when the
screen is waking up from X having it off (due to lid being closed or DPMS
turning it off). If I close and reopen the lid again I can see the correct
display for a second before the stripes cover it up again. The system is
interactive and I can blindly work with the windows.

I've found that plugging in my external monitor and using xrandr to enable it
fixes the problem. I've been messing around with various xrandr commands to see
if I can come up with something that fixes the problem without having the
actual physical external monitor plugged in but have had no luck so far.

Matthias Schmidt (mschmidt) wrote :

I just installed a fresh copy oneiric amd64 on my Thinkpad X220 i5-2520M. Without the extra kernel parameter my power consumption is about 16W, w/ the parameter it is about 8W in idle state.

I do not saw the graphic errors after some hours of working and a suspend/resume cycle. Due to an older Linux kernel Sandybridge bug, I had the following line in /etc/rc.local to set a sysfs value. Maybe the value prevents the graphics from getting corrupted:

echo -n 1 > /sys/module/i915/parameters/semaphores

Does this help anyone w/ the bug here?

hanfkeks (c-weber23) wrote :

same problem here,
pcie_aspm=force acpi=noirq
or
i915.i915_enable_rc6=1

by itself didn t do any good, but in combination it helped me on a
oneiric amd64 on my Thinkpad X220i with an i3.

same problem here on the x220i (oneiric 32bit). the combination of both
settings work for me too, battery usage went down from 15 to 8 watt!
On Oct 16, 2011 1:30 AM, "hanfkeks" <email address hidden> wrote:

> same problem here,
> pcie_aspm=force acpi=noirq
> or
> i915.i915_enable_rc6=1
>
> by itself didn t do any good, but in combination it helped me on a
> oneiric amd64 on my Thinkpad X220i with an i3.
>
> --
> You received this bug notification because you are subscribed to the bug
> report.
> https://bugs.launchpad.net/bugs/818830
>
> Title:
> [Sandy Bridge] serious power regression from kernel 3.0.0-6 to 3.0.0-7
> (rc6 disabled)
>
> Status in “linux” package in Ubuntu:
> Triaged
>
> Bug description:
> On Ubuntu Oneiric, I discovered a serious power regression from Kernel
> 3.0.0-6-generic to 3.0.0-7-generic.
> It is on an Intel Sandy Bridge Laptop. Unplugging the laptop from ac power
> source I made the tests without any graphical user interface active with the
> same brightness and other settings. When I boot into the kernels I have the
> following idle power numbers with
>
> grep rate /proc/acpi/battery/BAT0/state:
>
> - Kernel 3.0.0-6: present rate: 1530-1560mW
> - Kernel 3.0.0-7: present rate: 1950-2020mW
>
> It is a more than 30% (!!!) increase in power usage withe the same hw,
> same settings, different Kernel version.
> Which is really annoying as the laptop fans start working above
> 1700-1800mw, so it is night and day in usage comfort the laptop with the two
> kernels.
>
> Here is the kernel log for both versions:
>
> Log with 3.0.0-6: http://pastebin.com/e0UER3zf
> Log with 3.0.0-7: http://pastebin.com/5JcrZ5Br
>
> Please let me know if you need any more data on this.
>
> The problem is 100% reproducible.
>
> To manage notifications about this bug go to:
> https://bugs.launchpad.net/ubuntu/+source/linux/+bug/818830/+subscriptions
>

Changed in linux (Ubuntu Oneiric):
status: New → Triaged
importance: Undecided → Medium

Hi All,

I just want to post some status information regarding this issue. I've been in contact with Intel and they are aware of this power regression issue being experienced on Sandy Bridge hardware. They are actively investigating a fix(es). They have confirmed that the root cause is the graphics RC6 disablement. The reason RC6 was disabled is because, as many of you have already confirmed, there are some critical bugs which are encountered when it is enabled. These include:

 * Hangs unless i915_enable_rc6=0
 * Hang on showing copy dashed frame on a large cell interval in LibreOffice Calc
 * Activating rc6 results in render glitches

I'll try and keep you updated with any additional information that I receive. Thanks.

Lennart Karssen (l.c.karssen) wrote :

Monday Thorsten Leemhuis wrote a comment on this bug and added a suggestion on how distributions might go around to solve it. I like his proposal. Read it at http://www.h-online.com/open/features/Kernel-Comment-Untapped-power-saving-potential-1361906.html

tags: added: kernel-key
Steven Keys (steevven1) wrote :

Good to hear that Intel is working on this; thanks for the update. I would like to point out, however, that this power problem has two separate symptoms that add up to give the huge power loss. The first is disabling rc6 (on Sandy Bridge) in kernels 3.x. The second has to do with "sparse irq" in the 3.x kernels causing excessive processor wakeups (also on Sandy Bridge), as documented in this related/duplicate bug's description: https://bugs.launchpad.net/ubuntu/+source/linux/+bug/834037

Should I file a new, separate bug report for the sparse irq problem? I thought the two problems might be related, but maybe not.

quarara (classic-art-showcase) wrote :

@Steven Keys
I'm experiencing video corruption and glitches as well with RC6 enabled. I experience high power consumption with the default Ubuntu 11.10 kernel setting.
My machine is a Dell Inspiron 15r N5110 - i3-2310M + HD3000

Hanine HAMZIOUI (hanynowsky) wrote :

Same problem on a Dell XPS 15

- Intel i7 2670QM.
- huge power loss (4 hours in windows 7 and 1h55 in Ubuntu 11.10).
- Linux L502X 3.0.0-12-generic #20-Ubuntu SMP Fri Oct 7 14:56:25 UTC 2011 x86_64 x86_64 x86_64 GNU/Linux

I just got aware of that, during today's conference when I wanted to write notes. I ended shamelessly using Windows Notepad.

Rocko (rockorequin) wrote :

@Hanine: do you have ironhide (https://launchpad.net/~mj-casalogic/+archive/ironhide/) or at least acpi-call installed? If not, the nvidia card on the XPS 15 will be on permanently and it draws a heck of lot of power even though it is doing nothing.

Hanine HAMZIOUI (hanynowsky) wrote :

I had doubts about it. Yes! I have Bumblebee installed. No doubt Nvidia would consume all the power.
I am going to switch it off and compare. Thanks Rocko for the guidance! I totally forgot that.

Hanine HAMZIOUI (hanynowsky) wrote :

@Rocko indeed.
I have enabled the Bumblebee experimental power management and now battery life is 3h15 instead of 2h00, and the fan is at comfort now while it has been soothing like hell.

reference: https://github.com/Bumblebee-Project/Bumblebee/wiki/ACPI-Removed

Steven Keys (steevven1) wrote :

So comments 20-23 are entirely unrelated to this particular bug, right? It has nothing to do with Sandy Bridge graphics drivers?

fz (fz0002) wrote :

Same here on my Thinkpad T420. i915.i915_enable_rc6=1 causes occasional freezes, but no video corruption.

mediterran81 (kyoshuu) wrote :

@Steven Keys Actually, they are not really related! Intel is working on this regression which is supposed to be resolved in Kernel 3.2. I do not remember the link where i read this.

Ron Ellis (rkeiii) wrote :

@mediterran81 Maybe you're referring to this.

https://lkml.org/lkml/2011/11/10/467

Kevin (kevinshlee) wrote :

Could anyone please tell me if there is any fresh news regarding this issue?

Changed in linux:
importance: Unknown → Medium
status: Unknown → Fix Released
Steven Keys (steevven1) wrote :

I see that the status in Linux is now "Fix released." Any details on this? Links? Information? Which version of the kernel so we can try it? Thanks!

mediterran81 (kyoshuu) wrote :

3.2

Steven Keys (steevven1) wrote :

So is this information out-of-date? http://www.phoronix.com/scan.php?page=news_item&px=MTAzNDg ....According to that article, rc6 was not enabled by default in 3.2 because of the graphical glitches/freezes some users experienced. So what happened? Did they fix rc6 so it doesn't cause those problems and enable it? Or what? Also, are you sure it's kernel 3.2 and not 3.2.1? Once there is an Ubuntu package available for kernel 3.2.1, I will test it on my ThinkPad X220.

Brad Heap (nzv8fan) wrote :

I am on Kernel 3.2 in 11.10... using the 12.04 Kernel Package.

My grub config is set to:
GRUB_CMDLINE_LINUX_DEFAULT="quiet splash pcie_aspm=force i915.i915_enable_rc6=1"

This has restored a lot of battery life and dramatically dropped the temp the cpu is running at. But it still half that of Windows 7 on the same machine.

Steven Keys (steevven1) wrote :

I have tested kernel 3.2.1 (from here: http://kernel.ubuntu.com/~kernel-ppa/mainline/v3.2.1-precise/ ) on my ThinkPad X220, and it seems to use a tad MORE power than kernel 3.0. I take it that you were just guessing at random, mediterran81 (post #30)? Anyone have any actual info about this?

Ian Howson (ian-mouldy) wrote :

I tested kernel 3.2.1 and saw no improvement in power consumption, even with i915_enable_fbc and i915_enable_rc6 set.

There are two commits tagged against the upstream bug (#38332). One makes a change and the other reverts it.

I don't think this bug is fixed.

mediterran81 (kyoshuu) wrote :

I mentioned 3.2 because it was tested in a recent thinkpad suffering the same disease. Battery life recovered about one hour and CPU temp dropped to 54 °C.

Steven Keys (steevven1) wrote :

Can someone with the authority to do so change the status of this bug to "Confirmed" from "Fix released?" Pretty sure it is not fixed.

@Steven: thank you for your interest in Ubuntu. The bug has been fixed upstream (i.e. in the kernel itself), it is not marked as fixed in Ubuntu. The status of this bug in Ubuntu is 'Triaged', which means that the bug is reproducible and contains enough information. So the bug is still open and there's no need to change its status.

Rafael P. (rafael-p) wrote :

Agreed, I didn't notice any change either, we need more reports of testings

mediterran81 (kyoshuu) wrote :

Here is a source confirming that the power regression is fixed for Kernel 3.3:

http://www.phoronix.com/scan.php?page=news_item&px=MTA0NjE

Steven Keys (steevven1) wrote :

Actually, mediterran81, the link you gave specifically states that this bug has NOT been fixed, and is an "ongoing headache for Intel." This is just further confirmation that is is not fixed.

mediterran81 (kyoshuu) wrote :

How come? The link says it is fixed in 3.3 (merging of Garrett Patch), while Ubuntu 12.04 will come with the patch included.
http://www.phoronix.com/scan.php?page=news_item&px=MTA0MTM

http://voices.canonical.com/user/50/tag/power/

Did I mis-read?

Kevin (kevinshlee) wrote :

mediterran81, probably you did.

The bug, http://www.phoronix.com/scan.php?page=news_item&px=MTA0MTM says it's fixed is, I think, the bug #760131
It is different from what we have in this bug ticket. The bug in this ticket is specific to Intel Sandy Bridge.

Please check out the comments 212 and 224 in the bug #760131

https://bugs.launchpad.net/ubuntu/+source/linux/+bug/760131/comments/212

https://bugs.launchpad.net/ubuntu/+source/linux/+bug/760131/comments/224

Please correct me if I'm wrong.

Kevin (kevinshlee) wrote :

Based on the comments 32, 33 and 34, I don't think it's fixed. Brad in the comment 32 says it's better than before, yet he also says "it still half that of Windows 7 on the same machine."

Why do I see "Fix Released"? Has anyone actually tested it properly before changing the issue status?

Steven Keys (steevven1) wrote :

mediterran81, the bug that Phoronix is saying is fixed is the ASPM power bug. It is entirely different than the bug that this report is about. This bug report refers to the Sandy Bridge-only bug relating to graphics drivers and RC6. This bug is not fixed. The ASPM power bug is fixed. On Sandy Bridge machines, this bug is MUCH more significant than the ASPM bug.

mediterran81 (kyoshuu) wrote :

I am sorry. Thanks Kevin and Steven.
I indeed confused the two bugs which I am subscribed to.

Kevin (kevinshlee) wrote :

OK, the kernel bug tracker says it was fixed but it looks like it was closed about a half year ago. I'm not sure why we Ubuntu users do still not have it.
Andrea Corbellini, could you please let us know exactly which kernel we need to use in order to test if it's really fixed?
If the bug was really fixed, it seems like we all used some wrong kernel for testing.

Kevin (kevinshlee) wrote :

mediterran81, yeah I understand. I subscribed to the both bug tickets and once I was confused too. :)

Kevin (kevinshlee) wrote :

Hmm, as Steven mentioned, this article http://www.phoronix.com/scan.php?page=news_item&px=MTA0NjE says
"- Intel RC6 by default still hasn't been figured out fully by Intel for the logic when it can be successfully enabled without causing issues. This is for Intel Sandy Bridge hardware, but at least for the next-generation Ivy Bridge it looks like it can be more safely handled without causing issues for a minority of users. RC6-by-default has been an ongoing headache for Intel. "

It doesn't sound like fixing this bug https://bugzilla.kernel.org/show_bug.cgi?id=38332 fixes the bug in this ticket.
It's so sad but I'm starting to think I should have bought a Macbook Air.

Changed in linux (Ubuntu Precise):
assignee: nobody → Canonical Kernel Team (canonical-kernel-team)
Changed in ubuntu-power-consumption:
status: New → Confirmed

fucking finally

http://www.phoronix.com/scan.php?page=news_item&px=MTA1NzA

everything you need to know. afix for 3.2 kernel is on the way

Steven Keys (steevven1) wrote :

Thank you for the information, Julius, but the article says that the fix will be seen in kernel 3.4 if I'm reading it correctly, no? Hopefully this fixes the awful battery life on my ThinkPad X220!

Jorge G (geojorg) wrote :

Can the patch be included in Kernel 3.2 ?

I would help testing if it get's backported to precise kernel or a ppa for testing or something.

The info on the patch is here: http://lists.freedesktop.org/archives/intel-gfx/2012-February/015075.html

Matthias Schmidt (mschmidt) wrote :

@ #50: What's the issue with your X220? I have one and my power consumption is about 8W using WLAN (battery lasts about 5h with the small 4 cell battery). I just use the kernel command options from the articles mentioned above. And yes, it runs stable :)

y the article says that they are trying to make a pointfix release for 3.2

Steven Keys (steevven1) wrote :

@ #52: Do you have the i5 or i7 processor? I have two X220's with i7's, and both experience graphical glitches and (rare) freezes with rc6 enabled.

Matthias Schmidt (mschmidt) wrote :

@ #54: Mine has the i5-2520M CPU @ 2.50GHz CPU. No glitches and no freezes. So it seems your different CPU causes you problems :/

Rocko (rockorequin) wrote :

fwiw, I have an i7-2630QM and I don't get any glitches or freezes with rc6 enabled with either the 3.2.x or 3.3-rc3 kernels. But it's a Dell L502x, not a Thinkpad.

Ian Howson (ian-mouldy) wrote :

I have an X220 with the i5-2520M and still experience this issue.

On Wed, Feb 15, 2012 at 6:28 PM, Matthias Schmidt
<email address hidden> wrote:
> @ #54: Mine has the i5-2520M CPU @ 2.50GHz CPU. No glitches and no
> freezes. So it seems your different CPU causes you problems :/
>
> --
> You received this bug notification because you are subscribed to the bug
> report.
> https://bugs.launchpad.net/bugs/818830
>
> Title:
>  [Sandy Bridge] serious power regression from kernel 3.0.0-6 to 3.0.0-7
>  (rc6 disabled)
>
> To manage notifications about this bug go to:
> https://bugs.launchpad.net/linux/+bug/818830/+subscriptions

Jorge G (geojorg) wrote :

I have a Samsung i5-2520M I have glitches and freezes when rc6 enable, testing the new patch for the last 2 days, i have none of the above.

Jorge G (geojorg) wrote :

On my other system wich is a Samsung Core I3-2357M I still have glitches and freezes when rc6 enable but I am not testing the new patched kernel http://people.canonical.com/~ogasawara/eugeni/rc6/ i will try it soon to see if the bug is fixed in that system to.

quarara (classic-art-showcase) wrote :

Same here! Thanks to this patch, I don't experience graphical glitches anymore!
My machine is a Dell Inspiron 15r N5110 - i3-2310M + HD3000

Steven Keys (steevven1) wrote :

With the kernel located here: http://people.canonical.com/~ogasawara/eugeni/rc6/ is rc6 enabled by default, or do we have to pass a kernel parameter to it to test it? If so, what parameter? Will test as soon as someone replies. Thanks.

Jorge G (geojorg) wrote :

First check dmesg|fgrep -i "rc6"

If it is enable it's on.

If not i915.i915_enable_rc6=1

Steven Keys (steevven1) wrote :

I have installed the 64-bit kernel from http://people.canonical.com/~ogasawara/eugeni/rc6/ on my ThinkPad X220 and added the kernel parameter "i915.i915_enable_rc6=1" (RC6 was off by default). Power consumption was decreased by 25-50%, extremely roughly. I will test it for several days and then report on whether I experience glitches or freezes, as I always previously have with RC6 enabled. Fingers crossed! Thanks for your help and contributions, everyone.

Steven Keys (steevven1) wrote :

I have tested the patched kernel for about 24 hours now, and it is working beautifully! My battery lasts almost 50% longer (6 hours vs 4.2 hours) than with RC6 disabled, and there are NO glitches or freezes so far!!! My CPU temperature has also been decreased HUGELY. Here's how to test it yourself (PLEASE REPORT BACK). These instructions presume 64-bit Ubuntu or Xubuntu. For 32-bit, you'll need to DL the 32-bit packages and change the commands accordingly:

1) Download the three files located here to your Desktop:
http://people.canonical.com/~ogasawara/eugeni/rc6/amd64/

2) Run this command:

cd ~/Desktop;sudo dpkg -i linux-headers-3.2.5-tunerc6v1_3.2.5-tunerc6v1_all.deb linux-headers-3.2.5-tunerc6v1-generic_3.2.5-tunerc6v1_amd64.deb linux-image-3.2.5-tunerc6v1-generic_3.2.5-tunerc6v1_amd64.deb

3) As root, edit /etc/default/grub such that the line
GRUB_CMDLINE_LINUX_DEFAULT reads like this:

GRUB_CMDLINE_LINUX_DEFAULT="quiet splash i915.i915_enable_rc6=1"

4) Run this command:

sudo update-grub

5) Reboot

6) Never install any kernel updates through Update Manager. They will
replace this patched kernel, which is bad. I recommend uninstalling
all other kernels through your package manager to make sure they don't
try to update, and manually check when you run Update Manager that
nothing beginning with "linux-" is being installed.

You can tell if you did it right by
running this command:

dmesg|fgrep -i "rc6"

after a fresh reboot. The last line of the output should say "enabling
RC6." Also, run:

uname -r

The output of that should tell you that you're running kernel 3.2.5-tunerc6.

Enjoy!

Steven Keys (steevven1) wrote :

So...This patched kernel is working great. Here are my concerns moving forward: 1) We need more people to test it and report back. 2) We need to push for this fix to be incorporated into the kernel that ships with Ubuntu/Xubuntu 12.04 (an LTS release)! 3) I suspect that this patched kernel does not contain the aspm power fix that was released several weeks ago. This fix combined with that one would be very useful. 4) After this new fix is well-tested and confirmed to work well on all Sandy Bridge systems, RC6 should definitely be enabled by default. This is huge.

Hi Everyone,

I see some of you have found the RC6 tunables test kernel I built. As a follow on to that I've been in touch with upstream and have pulled in a proposed patch which disables RC6p (deep RC6) for Sandy Bridge. Upstream claims that RC6p is what was responsible for the reports of hangs/graphics corruption issues when RC6 was enabled. I've then added a follow on patch to then enable plain RC6 by default for Sandy Bridge users. Both of these patches are available in the latest 3.2.0-17.26 kernel.

In order to help justify keeping these patches applied and providing Sandy Bridge users improved power savings by default (ie users will no longer need to pass in i915.i915_enable_rc6=1), I'd really appreciate if you could all review my call for testing which I posted to both the Ubuntu kernel-team and ubuntu-devel mailing lists:

https://lists.ubuntu.com/archives/kernel-team/2012-February/019029.html

If you could please test and provide your feedback on the PowerManagementRC6 wiki, I would greatly appreciate it.

https://wiki.ubuntu.com/Kernel/PowerManagementRC6

Thanks in advance.

Kevin (kevinshlee) wrote :

Thanks Leann.

I'd like to test it but I'm using Oneiric not Precise. Can I test it? If so, could you please tell me where I can get the kernel for Oneiric? I'm using Oneiric 64bit.

Unfortunately there is no Oneiric test kernel with the patch applied yet. We'd like to focus first on the current development kernel, ie Precise. Should the patch prove successful, upstream intends to submit the patch for the 3.0.y stable release and thus we would also be able to provide it for Oneiric through our normal SRU process. Thanks for your patience and understanding. If you are able and willing to test Precise, we'd appreciate it.

quarara (classic-art-showcase) wrote :

I'm still using Oneiric and I cannot test this kernel on Precise right now, but for what is worth the patched kernel from comment #64 works flawlessly on my system!

Steven Keys (steevven1) wrote :

Potentially bad news: I started experiencing freezes again on my X220 with RC6 enabled and the new (tunable RC6) kernel. The freezes only occur (so far) while using LibreOffice Calc, but they are exactly the same types of freezes I have experienced with RC6 before. I have not yet seen the graphical glitches appear as they used to, so that's good news at least. I can't be 100% sure these freezes are related to RC6 and not to LibreOffice Calc, so I'll keep testing, but I suspect that they may be linked to RC6 since I never had a problem with Calc before. I will report back. I would recommend that anyone testing RC6 should use their computer extensively for several days before reporting anything.

Brad Heap (nzv8fan) wrote :

Yes, yesterday I was having exactly the same problem with Libre Office Calc, RC6 and the 3.2 kernel -- off the top of my head release 17, in the end I booted the previously installed 3.2 kernel and had no issues.

Hi Steven and Brad,

Thanks for the additional testing and feedback.

First, if you could both really confirm this is related to RC6 by booting the 3.2.0-17.26 kernel but disabling RC6 (boot with i915.i915_enable_rc6=0). I just want to make sure RC6 is indeed the culprit.

If RC6 really is the root case of the issue, could each of you open a sparate bug regarding the Libre Office Calc issues you are seeing with RC6 enabled. Please use 'ubuntu-bug linux' when filing the new bugs. We can then mark one a duplicate of the other. I primarily just want to make sure we capture both of your specific hardware information. Also, if you could then please add your machine information to the PowerManagementRC6 wiki - https://wiki.ubuntu.com/Kernel/PowerManagementRC6 (under the Crowd Sourcing Test Results) and include a reference to the new bugs you opened, that would be great. Thanks in advance and keep us posted.

Steven Keys (steevven1) wrote :

Leann,

Excellent suggestion. I did a series of experiments, and here are my results:

Using kernel from post #61, RC6 on: LibreOffice crashes consistently (I tried it several times and through reboots) on one particular file when scrolling over charts.

Using kernel from post #61, RC6 off: LibreOffice crashes consistently (I tried it several times and through reboots) on one particular file when scrolling over charts.

Using kernel 3.0.0-13-generic with RC6 on: LibreOffice does NOT crash on that file, ever.

LibreOffice file is attached.

Steven Keys (steevven1) wrote :

It should be noted, however, that kernel 3.0.0-13 experiences graphical glitches and RANDOM freezes with RC6 enabled, while the kernel from post #61 is cured of those symptoms.

Steven Keys (steevven1) wrote :

Sorry for flooding you all with comments, but I just noticed some poor word choice on my part in post #73. LibreOffice doesn't merely "crash." The entire computer freezes, and nothing responds in any way except that the mouse pointer is still movable, and I am still able to reboot using SysRq + R-E-I-S-U-B. This is similar to what used to happen to me at random with RC6 turned on, on other kernels.

Hi Steven et al,

So there have been some new developments regarding the RC6 patch which was applied. Upstream recently discovered an issue and has proposed the following additional patch:

http://lists.freedesktop.org/archives/intel-gfx/2012-February/015319.html

I apologize for asking for even more testing, but could you give the following kernel a test:

http://kernel.ubuntu.com/~sarvatt/rc6/

I'm really hoping it might solve the issues you are seeing. Please let me know your results. Thanks in advance.

Seth Forshee (sforshee) wrote :

I've been running with rc6 enabled for most of the precise development cycle, and I never observed the destkop hangs but have started seeing them recently. I can't say for certain whether or not they started with the 3.2.0-17.26 kernel. But the machine is very much alive when it happens; I can switch to a VT, the apps on my desktop still seem to be running (based on the fact that they still use some CPU), and I can get back to a functioning desktop with 'sudo service lightdm restart'. I'm seeing a strong correlation between these hangs and scrolling in a window, especially when I'm scrolling in chromium.

However, after upgrading this morning I'm not able to reproduce these hangs. I had a couple of pretty reliable ways of reproducing the issue, and neither of them are working. There were some libgl1-mesa updates when I upgraded, which could be related. So I'd suggest getting up-to-date on precise and seeing if the hangs are still reproducible (independently of testing Leann's kernel, so that it's clear what fixed the issue if it does go away).

Hi All,

Just to reiterate what Seth said above in comment #77. We just uploaded a new ubuntu kernel, 3.2.0-17.27. It contains the additional fix mentioned in comment #76. We hope this should resolve any of the remaining issues being seen with RC6 enabled. If you could please test and let us know your results both here and at https://wiki.ubuntu.com/Kernel/PowerManagementRC6 it would be greatly appreciated. Thanks.

https://launchpad.net/ubuntu/+source/linux/3.2.0-17.27

Steven Keys (steevven1) wrote :

I tried to test the kernel in comment #76 by installing the .deb packages, but I got errors...Can someone help me? I'd love to test it because I have a consistent way of triggering the freezes with the "tunerc6" kernel in comment #61. Here is the output I get when I try to install it:

[18:24:49 | steven]<~/Desktop>$ sudo dpkg -i linux-headers-3.2.0-17_3.2.0-17.26+rc6notrc6p_all.deb linux-headers-3.2.0-17-generic_3.2.0-17.26+rc6notrc6p_amd64.deb linux-image-3.2.0-17-generic_3.2.0-17.26+rc6notrc6p_amd64.deb
[sudo] password for steevven1:
Selecting previously deselected package linux-headers-3.2.0-17.
(Reading database ... 279653 files and directories currently installed.)
Unpacking linux-headers-3.2.0-17 (from linux-headers-3.2.0-17_3.2.0-17.26+rc6notrc6p_all.deb) ...
Selecting previously deselected package linux-headers-3.2.0-17-generic.
Unpacking linux-headers-3.2.0-17-generic (from linux-headers-3.2.0-17-generic_3.2.0-17.26+rc6notrc6p_amd64.deb) ...
Selecting previously deselected package linux-image-3.2.0-17-generic.
Unpacking linux-image-3.2.0-17-generic (from linux-image-3.2.0-17-generic_3.2.0-17.26+rc6notrc6p_amd64.deb) ...
Done.
Setting up linux-headers-3.2.0-17 (3.2.0-17.26+rc6notrc6p) ...
dpkg: dependency problems prevent configuration of linux-headers-3.2.0-17-generic:
 linux-headers-3.2.0-17-generic depends on libc6 (>= 2.14); however:
  Version of libc6 on system is 2.13-20ubuntu5.
dpkg: error processing linux-headers-3.2.0-17-generic (--install):
 dependency problems - leaving unconfigured
Setting up linux-image-3.2.0-17-generic (3.2.0-17.26+rc6notrc6p) ...
Running depmod.
update-initramfs: deferring update (hook will be called later)
Examining /etc/kernel/postinst.d.
run-parts: executing /etc/kernel/postinst.d/dkms 3.2.0-17-generic /boot/vmlinuz-3.2.0-17-generic
Error! Bad return status for module build on kernel: 3.2.0-17-generic (x86_64)
Consult /var/lib/dkms/vboxhost/4.1.8/build/make.log for more information.
run-parts: executing /etc/kernel/postinst.d/initramfs-tools 3.2.0-17-generic /boot/vmlinuz-3.2.0-17-generic
update-initramfs: Generating /boot/initrd.img-3.2.0-17-generic
run-parts: executing /etc/kernel/postinst.d/pm-utils 3.2.0-17-generic /boot/vmlinuz-3.2.0-17-generic
run-parts: executing /etc/kernel/postinst.d/update-notifier 3.2.0-17-generic /boot/vmlinuz-3.2.0-17-generic
run-parts: executing /etc/kernel/postinst.d/zz-update-grub 3.2.0-17-generic /boot/vmlinuz-3.2.0-17-generic
Generating grub.cfg ...
Found linux image: /boot/vmlinuz-3.2.5-tunerc6v1-generic
Found initrd image: /boot/initrd.img-3.2.5-tunerc6v1-generic
Found linux image: /boot/vmlinuz-3.2.0-17-generic
Found initrd image: /boot/initrd.img-3.2.0-17-generic
Found linux image: /boot/vmlinuz-3.0.0-13-generic
Found initrd image: /boot/initrd.img-3.0.0-13-generic
Found memtest86+ image: /memtest86+.bin
done
Errors were encountered while processing:
 linux-headers-3.2.0-17-generic

Steven Keys (steevven1) wrote :

Actually, I was still able to boot into the new 3.2.0-17.27 kernel from comment #76 despite the installation errors. The LibreOffice freeze still occurs. The strange thing is that it occurs with RC6 on or off though, and it doesn't occur at all with kernel 3.0 (RC6 or not). It seems to have no RC6 dependence on any kernel.

Thanks Steven. Let's have you open a new separate bug for the new issue you are seeing. It doesn't appear to be related to the RC6 issue and warrants a separate bug. Thanks.

lates kernel fixes al isssues on toshiba satzellite r850-14T
im using quiet splash nmi_watchdog=0 i915.i915_enable_rc6=3 i915.lvds_downclock=1 i915.i915_enable_fbc=1 rm.vblankoffdelay=1

Steven Keys (steevven1) wrote :

I'm not sure if this is of any relevance here, but I have tested the upstream kernel (3.3.0-030300rc5-generic, http://kernel.ubuntu.com/~kernel-ppa/mainline/v3.3-rc5-precise/), and the graphical glitches occur in that kernel with RC6 enbled. I'm assuming that kernel does not contain Leann's fix? Please confirm.

Hi Steven,

That is correct, the upstream kernel does not yet contain this patch. As I understand it, it will be sent upstream and also submitted to upstream-stable once there is enough testing feedback to provide a level of confidence that there are no further regressions introduced from the patch. Our call for testing has helped with this. Based on feedback so far, things look promising. If they remain that way, I intend to ship these patches with our 12.04 kernel.

Steven Keys (steevven1) wrote :

Very cool. I doubt my opinion matters a whole lot, but I think this patch should ship with the 12.04 kernel, and RC6 (but not deep RC6) should be enabled by default (without passing a kernel parameter manually) for Sandy Bridge machines in 12.04. This is a HUGE power savings, and 12.04 is a very big release, being an LTS and all. I think all these power issues have really given Ubuntu a bad reputation.

Maarten Kossen (mpkossen) wrote :

3.2.0-17-generic is not completely stable for me. I get a complete visual freeze (sound keeps working) with this kernel about twice a day.

Hi Maarten,

Can you confirm this instability is due to RC6 (ie if you disable RC6 do the issues go away?). If so, may I ask that you open a separate bug report so that we can capture your specific hardware information. To open a new bug, please run the following command:

ubuntu-bug linux

Please be sure to include as much detail as you can in the new bug (eg steps to reproduce if possible, the fact disabling RC6 resolves the issue, etc.)

If the instability is not related to RC6, you should still open a separate bug report to address the issues you are seeing. Thanks.

Kevin (kevinshlee) wrote :

Could anyone tell me where I can get 3.2.0-17.27 for precise (64bit)?

Andy Whitcroft (apw) wrote :

@Maarten -- if you could describe when the complete visual freezes occur, that might help. For example there is a separate known issue where the X server locks hard due to an internal deadlock; this most commonly occurs when touching the left edge to get the unity launcher.

Andy Whitcroft (apw) wrote :

@Kevin -- the fixes should be in the latest kernel in the archive if you update.

Maarten Kossen (mpkossen) wrote :

@Andy: yes, it is always the left edge. Do you have a bug number for me
so I can follow that as well, please?

On 03/05/2012 02:02 PM, Andy Whitcroft wrote:
> @Maarten -- if you could describe when the complete visual freezes
> occur, that might help. For example there is a separate known issue
> where the X server locks hard due to an internal deadlock; this most
> commonly occurs when touching the left edge to get the unity launcher.
>

Hi All,

Given the positive testing feedback with the RC6 patches, we intend to keep them applied for Precise. If anyone is experiencing RC6 related issues, please file a new bug and let us know. For now I'm marking this power regression issue as Fix Released for Precise. As mentioned earlier, I believe these RC6 patches will be making their way to upstream stable and thus should land in Oneiric as an SRU in due time. Thanks again to everyone for the testing and feedback.

Changed in linux (Ubuntu Precise):
status: Triaged → Fix Released
Steven Keys (steevven1) wrote :

Leann, I think that keeping these patches applied (and having RC6 enabled by default) in 12.04 is definitely the way to go. Just wanted to thank you for all your help. This bug was killer for me personally, and you were a massive help with it!

Changed in ubuntu-power-consumption:
status: Confirmed → Fix Released
tags: removed: kernel-key
Claus Strasburger (w-claus) wrote :

Just a final question:
I am running Linux Mint 12, which is still on Oneiric.
Is this final fix embedded in any upstream kernel.org version and if so, at which version?
Is the fix somewhere in http://kernel.ubuntu.com/~kernel-ppa/mainline/ ?
How do i get a kernel for other distro's (e.g. Debian/Arch)?

Maarten Kossen (mpkossen) wrote :

@Claus Strasburger See comment #64 (https://bugs.launchpad.net/ubuntu/+source/linux/+bug/818830/comments/64) for information on how to patch an Oneiric kernel.

victor alvarado (vito8916) wrote :

tengo la version del kernel 3.2.3 y mi dell inspiron N4110 se recalienta y la bateria dura muy poco

Changed in linux (Ubuntu Precise):
assignee: Canonical Kernel Team (canonical-kernel-team) → victor alvarado (vito8916)
Daniel Manrique (roadmr) wrote :

Please do not assign yourself to bugs unless you're actually working on fixing them.

Thanks!

Changed in linux (Ubuntu Precise):
assignee: victor alvarado (vito8916) → Canonical Kernel Team (canonical-kernel-team)

Oneiric is EOL so someone should set this to wont fix

Changed in linux (Ubuntu Oneiric):
status: Triaged → Won't Fix
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers

Remote bug watches

Bug watches keep track of this bug in other bug trackers.